from sklearn.neural_network import MLPClassifier
import random

f = open("data.txt")
data = f.readlines()
X = []
Y = []

for i in range(0, len(data), 1):
    l = data[i].split()
    Y.append(float(l[0]))
    l2 = []
    for j in range(1, len(l), 1):
        l2.append(float(l[j]))
    X.append(l2)

#print(X)
#print(Y)

bestseed = 0
bestloss = 10000000
for i in range(0, 10, 1):
    r = random.randint(0,10000000)    
    clf = MLPClassifier(solver='lbfgs', activation='logistic', hidden_layer_sizes=(2),max_iter=1000,alpha=.001,random_state=r)
    clf.fit(X,Y)
    if(clf.loss_ < bestloss):
        bestloss = clf.loss_
        bestseed = r
    print(clf.loss_, bestloss)

clf = MLPClassifier(solver='lbfgs', activation='logistic', hidden_layer_sizes=(2),max_iter=1000,alpha=.001,random_state=bestseed)
clf.fit(X,Y)
prediction = clf.predict(X)
print("prediction=",prediction)
print("truelabels=",Y)
print("loss=", clf.loss_)

#print(clf.coefs_)
#print(clf.intercepts_)

u = [clf.coefs_[0][0][0], clf.coefs_[0][1][0]]
v = [clf.coefs_[0][0][1], clf.coefs_[0][1][1]]
print(u)
print(v)

u0 = clf.intercepts_[0][0]
v0 = clf.intercepts_[0][1]
print(u0,v0)

for i in range(0, len(X), 1):
        dp_u = 0
        dp_v = 0                
        for j in range(0, len(X[0]), 1):
                dp_u = dp_u + X[i][j] * u[j]
                dp_v = dp_v + X[i][j] * v[j] 
        dp_u += u0
        dp_v += v0
        if(dp_u > 0):
                s_u = 1
        else:
                s_u = -1
        if(dp_v > 0):
                s_v = 1
        else:
                s_v = -1

        print(dp_u, s_u, dp_v, s_v)
        
w1 = clf.coefs_[1][0]
w2 = clf.coefs_[1][1]
w = (w1,w2)

print(w)

#print(testlabels)

'''
err = 0
for i in range(0, len(prediction), 1):
    if(prediction[i] != testlabels[i]):
        err += 1
err = err/len(testlabels)
print(err)
'''


            
            
